import 'package:equatable/equatable.dart';
import 'package:intl/intl.dart';
import 'package:meta/meta.dart';

class ActiveCase extends Equatable
{
  final String id;
  final DateTime startDate;

  ActiveCase({@required this.id, @required this.startDate});

  Map<String, dynamic> toJson() {
    return {
      "id": id,
      "startDate": DateFormat("yyyy-MM-dd HH:mm:ss").format(startDate),
    };
  }

  factory ActiveCase.fromJson(Map<String, dynamic> parsedJson) {
    return ActiveCase(
      id: parsedJson["id"],
      startDate:  DateTime.parse(parsedJson["startDate"]),
    );
  }

  @override
  List<Object> get props => [id, startDate];

  @override
  String toString() => "ActiveCase(id: " + id + ", startDate: " + DateFormat("yyyy-MM-dd HH:mm:ss").format(startDate) + ")";
}