import '../data_classes/active_case.dart';
import '../data_sources/active_cases_data_source_local.dart';

class ActiveCasesRepositoryLocal
{
  ActiveCasesDataSourceLocal _dataSource = ActiveCasesDataSourceLocal();

  Future<List<ActiveCase>> getActiveCases() async
  {
    try {
      final result = await _dataSource.getActiveCases();
      print("HEROES_FLUTTER_PLUGIN :: ActiveCasesRepository :: " + (result != null ? "Got" : "Did not get") + " active cases.");
      return result;
    }
    catch (exception){
      print("HEROES_FLUTTER_PLUGIN :: ActiveCasesRepository :: Did not get active cases.");
      print("HEROES_FLUTTER_PLUGIN :: ActiveCasesRepository :: " + exception.toString());
      return null;
    }
  }

  Future<bool> saveActiveCases(List<ActiveCase> activeCases) async
  {
    try {
      final success = await _dataSource.saveActiveCases(activeCases);
      print("HEROES_FLUTTER_PLUGIN :: ActiveCasesRepository :: " + (success ? "Saved" : "Did not save") + " active cases: " + activeCases.toString());
      return success;
    }
    catch (exception){
      print("HEROES_FLUTTER_PLUGIN :: ActiveCasesRepository :: Did not save active cases: " + activeCases.toString());
      print("HEROES_FLUTTER_PLUGIN :: ActiveCasesRepository :: " + exception.toString());
      return false;
    }
  }
}