import '../app_clock_service/app_clock.dart';
import '../data_service/data_service.dart';
import '../nearby_connections_service/nearby_connections_proximity_detection.dart';

class DetectionService
{
  static final _instance = DetectionService._internal();
  factory DetectionService() => _instance;
  DetectionService._internal();

  bool _isStarted = false;
  bool get isStarted => _isStarted;

  Future<void> start() async
  {
    if (_isStarted)
      return null;

    print("HEROES_FLUTTER_PLUGIN :: DetectionService :: start()");
    NearbyConnectionsProximityDetection().detectionService = this;
    await NearbyConnectionsProximityDetection().startScanning();
    _isStarted = true;
    return null;
  }

  Future<void> stop() async
  {
    if (!_isStarted)
      return null;
    
    print("HEROES_FLUTTER_PLUGIN :: DetectionService :: stop()");
    AppClock().stopIsolate();
    await NearbyConnectionsProximityDetection().stopScanning();
    _isStarted = false;
    return null;
  }

  void startEncounter(String id, DateTime timeOfEncounter)
  {
    DataService().startEncounter(id, timeOfEncounter);
  }

  void endEncounter(String id)
  {
    DataService().finishEncounter(id);
  }

  void endAllEncounters()
  {
    DataService().finishAllEncounters();
  }
}
