import 'encounter_position.dart';
import 'package:intl/intl.dart';
import 'package:meta/meta.dart';

class EncounterEntry
{
  final String theirId;
  List<EncounterPosition> positions;
  final DateTime fistTime;
  DateTime lastTime;

  EncounterEntry({
    @required this.theirId,
    @required this.positions,
    @required this.fistTime,
    @required this.lastTime,
  });

  Map<String, dynamic> toJson() {

    List<Map> positions = this.positions != null
        ? this.positions.map((i) => i.toJson()).toList()
        : null;
    return {
      "theirId": theirId,
      "positions": positions,
      "firstTime": DateFormat("yyyy-MM-dd HH:mm:ss").format(fistTime),
      "lastTime": DateFormat("yyyy-MM-dd HH:mm:ss").format(lastTime)
    };
  }

  factory EncounterEntry.fromJson(Map<String, dynamic> parsedJson) {
    var list = parsedJson['positions'] as List;
    List<EncounterPosition> positions =
    list.map((i) => EncounterPosition.fromJson(i)).toList();
    return EncounterEntry(
        theirId: parsedJson['theirId'],
        positions: positions,
        fistTime: DateTime.parse(parsedJson['firstTime']),
        lastTime: DateTime.parse(parsedJson['lastTime'])
    );
  }
}