import 'encounter_entry.dart';
import 'package:meta/meta.dart';

class EndedEncounter
{
  final String theirId;
  final List<EncounterEntry> encounters;

  EndedEncounter({@required this.theirId, @required this.encounters});

  Map<String, dynamic> toJson()
  {
    final encountersListAsJson = List<Map<String, dynamic>>();
    for (int i=0; i<encounters.length; i++)
      encountersListAsJson.add(encounters[i].toJson());

    return {
      "theirId": theirId,
      "encounters": encountersListAsJson,
    };
  }

  factory EndedEncounter.fromJson(Map<String, dynamic> json)
  {
    final List<dynamic> encountersAsJsonBeforeParsing = json["encounters"];
    final encountersAsJson = List<Map<String, dynamic>>();
    for(int i=0; i<encountersAsJsonBeforeParsing.length; i++)
      encountersAsJson.add(encountersAsJsonBeforeParsing[i]);

    final encountersAsList = List<EncounterEntry>();

    for (int i=0; i<encountersAsJson.length; i++)
      encountersAsList.add(new EncounterEntry(theirId: encountersAsJson[i]["theirId"],
        positions: encountersAsJson[i]["positions"],
        fistTime: DateTime.parse(encountersAsJson[i]["firstTime"]),
        lastTime: DateTime.parse(encountersAsJson[i]["lastTime"]),
      ));

    return EndedEncounter(
      theirId: json["theirId"],
      encounters: encountersAsList,
    );
  }
}