import 'encounter_entry.dart';
import 'ended_encounter.dart';

class EndedEncountersJsonTransformer
{
  static Map<String, dynamic> toJson(Map<String, List<EncounterEntry>> endedEncounters)
  {
    //We go row by row in the map
    final List<MapEntry<String, List<EncounterEntry>>> endedEncountersAsList = endedEncounters.entries.toList();

    //We use EndedEncounter to fill a list, because of its very convenient toJson function
    final endedEncountersListAsJsonList = List<Map<String, dynamic>>();

    for (int i=0; i<endedEncountersAsList.length; i++)
    {
      EndedEncounter value = EndedEncounter(
        theirId: endedEncountersAsList[i].key,
        encounters: endedEncountersAsList[i].value,
      );
      endedEncountersListAsJsonList.add(value.toJson());
    }

    return {
      "dateTime" : DateTime.now().toString(),
      "savedEncounters" : endedEncountersListAsJsonList
    };
  }

  static Map<String, List<EncounterEntry>> fromJson(Map<String, dynamic> json)
  {
    //Map we will return
    final map = Map<String, List<EncounterEntry>>();
    final entryList = List<MapEntry<String, List<EncounterEntry>>>();

    final List<dynamic> encountersAsJsonBeforeParsing = json["savedEncounters"];
    final encountersAsJson = List<Map<String, dynamic>>();
    for(int i=0; i<encountersAsJsonBeforeParsing.length; i++)
      encountersAsJson.add(encountersAsJsonBeforeParsing[i]);

    for (int i=0; i<encountersAsJson.length; i++) {
      final encounterEntryList = List<EncounterEntry>();

      final List<Map<String, dynamic>> encounterEntryListAsJson = List<Map<String, dynamic>>();


      //We need to decode this first
      final List<dynamic> dynamicList = encountersAsJson[i]["encounters"];

      for (int i=0; i<dynamicList.length; i++)
        encounterEntryListAsJson.add(dynamicList[i]);


      for (int i=0; i<encounterEntryListAsJson.length; i++) {
        encounterEntryList.add(EncounterEntry.fromJson(encounterEntryListAsJson[i]));
      }

      final mapEntry = MapEntry<String, List<EncounterEntry>>(encountersAsJson[i]["theirId"], encounterEntryList);
      entryList.add(mapEntry);
    }

    map.addEntries(entryList);
    return map;
  }
}