import '../data_classes/encounter_entry.dart';
import '../data_sources/encounters_data_source_local.dart';

class EncountersRepository
{
  EncountersDataSource _dataSource = EncountersDataSource();

  Future<Map<String, List<EncounterEntry>>> getEncounters() async
  {
    try {
      final result = await _dataSource.getEncounters();
      print("HEROES_FLUTTER_PLUGIN :: EncountersRepository :: " + (result != null ? "Got" : "Did not get") + " encounters map.");
      return result;
    }
    catch (exception){
      print("HEROES_FLUTTER_PLUGIN :: EncountersRepository :: Did not get encounters map.");
      print("HEROES_FLUTTER_PLUGIN :: EncountersRepository :: " + exception.toString());
      return null;
    }
  }

  Future<bool> saveEncounters(Map<String, List<EncounterEntry>> encountersMap) async
  {
    try {
      final success = await _dataSource.saveEncounters(encountersMap);
      print("HEROES_FLUTTER_PLUGIN :: EncountersRepository :: " + (success ? "Saved" : "Did not save") + " encounters map.");
      return success;
    }
    catch (exception){
      print("HEROES_FLUTTER_PLUGIN :: EncountersRepository :: Did not save encounters map.");
      print("HEROES_FLUTTER_PLUGIN :: EncountersRepository :: " + exception.toString());
      return false;
    }
  }
}