import 'package:shared_preferences/shared_preferences.dart';

class RegistrationDataSourceSharedPreferences
{
  final String _userIDKey = "Heroes_userID";
  final String _invitationCodesKey = "Heroes_invitationCodes";
  SharedPreferences _sharedPreferences;

  RegistrationDataSourceSharedPreferences._internal();

  static Future<RegistrationDataSourceSharedPreferences> getNewInstance() async
  {
    final instance = RegistrationDataSourceSharedPreferences._internal();
    instance._sharedPreferences = await SharedPreferences.getInstance();
    return instance;
  }

  String getUserID()
  {
    if (_sharedPreferences.containsKey(_userIDKey))
      return _sharedPreferences.getString(_userIDKey);
    else
      return null;
  }

  Future<bool> setUserID(String userID) async
  {
    return await _sharedPreferences.setString(_userIDKey, userID);
  }

  List<String> getInvitationCodes()
  {
    if (_sharedPreferences.containsKey(_invitationCodesKey))
      return _sharedPreferences.getStringList(_invitationCodesKey);
    else
      return null;
  }

  Future<bool> setInvitationCodes(List<String> invitationCodes) async
  {
    return await _sharedPreferences.setStringList(_invitationCodesKey, invitationCodes);
  }
}