import 'package:location/location.dart';

class UtilsService {
  factory UtilsService() => _instance;

  UtilsService._internal();

  static final _instance = UtilsService._internal();

  Future<bool> checkLocationServiceEnabled() async {
    Location location = new Location();
    bool result = await location.serviceEnabled();

    if (!result) result = await location.requestService();

    return result;
  }

  Future<bool> checkLocationPermissions() async
  {
    Location location = new Location();
    PermissionStatus _permissionGranted = await location.hasPermission();
    if (_permissionGranted == PermissionStatus.GRANTED) {
      print("HEROES_FLUTTER_PLUGIN :: LOCATION_PERMISSIONS :: requested_in_app :: granted");
    }
    else if (_permissionGranted == PermissionStatus.DENIED){
      print("HEROES_FLUTTER_PLUGIN :: LOCATION_PERMISSIONS :: requested_in_app :: denied");
    }
    else if (_permissionGranted == PermissionStatus.DENIED_FOREVER){
      print("HEROES_FLUTTER_PLUGIN :: LOCATION_PERMISSIONS :: requested_in_app :: denied forever");
    }
    else {
      print("HEROES_FLUTTER_PLUGIN :: LOCATION_PERMISSIONS :: requested_in_app :: other");
    }
    return _permissionGranted == PermissionStatus.GRANTED;
  }
}
